extern double     Lots             = 1;
extern int        MaxTrades    = 1;
extern double     MaximumRisk      = 0.1;
extern double     DecreaseFactor   = 1;
extern bool       PrefSettings     = true;
extern bool       MM               = true;
extern bool       AccountIsMicro   = false;
extern int        TakeProfit       = 0;
extern int        StopLoss         = 0;
extern int        TrailingStop     = 2;
extern double     lTrailingStop = 2;
extern double     sTrailingStop = 2;
extern int        FastMA_Period=2;
extern int        FastMA_Shift=0;
extern int        FastMA_Method=3;
double            FastExtMapBuffer[];
extern int        SlowMA_Period=200;
extern int        SlowMA_Shift=0;
extern int        SlowMA_Method=0;
double            SlowExtMapBuffer[];
extern bool       UseSignal1       = true;
extern bool   ReverseSignal= false;
extern int    MagicNumber  = 772188;
datetime TimeStamp=0;

bool Buy=false,Sell=false;

int init()
{
   if(Digits==3 || Digits==5)
   StopLoss=StopLoss*10;
   TakeProfit=TakeProfit*10;
   TrailingStop=TrailingStop*10;
return(0);
}

int TotalOrders(int OrdersMagic)
{
   int Total=0;
   for(int cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==OrdersMagic)
      Total++;
   }
   return(Total);
}

int start()
{
   int cnt;
   double sl,tp;

   if(Bars<2000)
   {
      Comment("History data less than 2000, kindly download from history centre and restart EA");
      return(0);  
   }
   
   double MA1=iCustom(NULL,0,"Moving Averages",FastMA_Period,0,FastMA_Method,0,FastMA_Shift,0);
   double MA2=iCustom(NULL,0,"Moving Averages",SlowMA_Period,0,SlowMA_Method,0,SlowMA_Shift,0);
   
   if(UseSignal1)
      {
            if((MA1 < MA2)) 
            {
                     if(!ReverseSignal)
         {
            Buy=true;
            
         }
         else
                  Sell= true;
            } 
            if(MA1 > MA2)   
            {
                     if(!ReverseSignal)
         {
            
            Sell=true;
         }
         else
                  Buy= true;
            }
      }
      
      
   if(TotalOrders(MagicNumber)<MaxTrades && TimeStamp!=iTime(NULL,0,0))
   {
      if(AccountFreeMargin()<(100*Lots))
        {
         Comment("No money. Kindly top up account or change to a smaller lot size. Account free margin = ", AccountFreeMargin());
         return(0);
         }
         if(Buy && !Sell)
      {
         if(TakeProfit>10)tp=Ask+TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Bid-StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sl,tp,"CycleSurfer",MagicNumber,0,DodgerBlue)==-1)
         Print("Error opening BUY order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }

      if(Sell && !Buy)
      {
         if(TakeProfit>10)tp=Bid-TakeProfit*Point;
         else tp=0;
         if(StopLoss>10)sl=Ask+StopLoss*Point;
         else sl=0;
         if(OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sl,tp,"CycleSurfer",MagicNumber,0,FireBrick)==-1)
         Print("Error opening SELL order : ",GetLastError()); 
         else
         TimeStamp=iTime(NULL,0,0);
      }
   }

 for(cnt=0;cnt<OrdersTotal();cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
            if(OrderType()==OP_BUY)
            {
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
               {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                }
               }
            }
            if(OrderType()==OP_SELL)
            {                 
              if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
              {
               if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
               }
              }
            }
         }
      }

   return(0);
}